﻿using System;
using System.Linq.Expressions;
using System.Linq;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Collections.Generic;
namespace RepositoryEFCodeFirst
{
  public interface IEFRepository<TContext> : IDisposable
     where TContext : DbContext, IObjectContextAdapter, new()
  {

    void Delete<TItem>(TItem item) where TItem : class, new();
    
    TItem Insert<TItem>(TItem item) where TItem : class, new();
    
    IEnumerable<TItem> Select<TItem>() where TItem : class, new();

    IEnumerable<TItem> Select<TItem>(Expression<Func<TItem, bool>> whereClause) where TItem : class, new();

    IEnumerable<TItem> Select<TItem>(Expression<Func<TItem, bool>> whereClause, Expression<Func<TItem, object>> orderBy) 
      where TItem : class, new();
    
    TItem Update<TItem>(TItem item) where TItem : class, new();
  }
}
