﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity;

namespace RepositoryEFCodeFirst
{
  class Program
  {
    static UnityContainer container = new UnityContainer();

    static void Main(string[] args)
    {

      container.RegisterType<IEFRepository<ProductContext>, EFRepository<ProductContext>>(
        new ContainerControlledLifetimeManager());

      using (var repository = container.Resolve<IEFRepository<ProductContext>>())
      {
        Console.WriteLine("Total products in DB : " +
            repository.Select<Product>().Count().ToString());

        Product newProduct = new Product();
        newProduct.ProducName = "Plates";
        newProduct.ProducNumber = "001";
        newProduct.Notes = "SOme notes for plates";
        newProduct.IsActive = true;

        newProduct = repository.Insert(newProduct);

        var ordered = repository.Select<Product>()
          .Where(one => one.IsActive == true)
          .OrderBy(one => one.ProducNumber).ToList();

        Console.WriteLine("New id is " + newProduct.ProductId.ToString());


        var aProduct = repository.Select<Product>().Where(one => one.IsActive).First();

        var activeProducts = repository.Select<Product>(one => one.IsActive).ToList();

        var activeOrderedProducts =
          repository.Select<Product>(one => one.IsActive, one => one.ProducName).ToList();

        aProduct.ProducName = "Updated Plates";

        aProduct = repository.Update(aProduct);

        aProduct = repository.Select<Product>()
          .Where(one => one.ProductId == newProduct.ProductId).First();

        Console.WriteLine("Update name is: " + aProduct.ProducName.ToString());

        repository.Delete(aProduct);

      }
    }
  }
}
